package com.genability.client.api.request;

import java.util.ArrayList;
import java.util.List;

import org.apache.http.NameValuePair;

public abstract class AbstractGetNRequest extends AbstractRequest {

	/**
	 * Value to use when wanting to sort on a field in ascending order.
	 */
	public static final String ASCENDING = "ASC";

	/**
	 * Value to use when wanting to sort on a field in descending order.
	 */
	public static final String DESCENDING = "DESC";
	
	
	private Integer pageStart;

	private Integer pageCount;

	protected String search;
	
	protected String searchOn;

	protected Boolean startsWith;

	protected Boolean endsWith;
	
	protected Boolean isRegex;
	
    protected String sortOn;
    
    protected String sortOrder;

    
	/**
	 * @param pageStart
	 *            to set
	 */
	public void setPageStart(Integer pageStart) {
		this.pageStart = pageStart;
	}

	/**
	 * @return the pageStart
	 */
	public Integer getPageStart() {
		return pageStart;
	}

	/**
	 * @param appKey
	 *            the pageCount to set
	 */
	public void setPageCount(Integer pageCount) {
		this.pageCount = pageCount;
	}

	
	
	public String getSearch() {
		return search;
	}

	public void setSearch(String search) {
		this.search = search;
	}

	public String getSearchOn() {
		return searchOn;
	}

	public void setSearchOn(String searchOn) {
		this.searchOn = searchOn;
	}
	
	public Boolean getStartsWith() {
		return startsWith;
	}

	public void setStartsWith(Boolean startsWithWildCard) {
		this.startsWith = startsWithWildCard;
	}

	public Boolean getEndsWith() {
		return endsWith;
	}

	public void setEndsWith(Boolean endsWith) {
		this.endsWith = endsWith;
	}

	public Boolean getIsRegex() {
		return isRegex;
	}

	public void setIsRegex(Boolean isRegex) {
		this.isRegex = isRegex;
	}
	
	/**
	 * @return the pageCount
	 */
	public Integer getPageCount() {
		return pageCount;
	}

	public String getSortOn() {
		return sortOn;
	}

	public void setSortOn(String sortOn) {
		this.sortOn = sortOn;
	}

	public String getSortOrder() {
		return sortOrder;
	}

	public void setSortOrder(String sortOrder) {
		this.sortOrder = sortOrder;
	}

	protected List<NameValuePair> getQueryParams() {
		
		List<NameValuePair> qparams = new ArrayList<NameValuePair>();
		addParam(qparams, "pageStart", pageStart);
		addParam(qparams, "pageCount", pageCount);
		addParam(qparams, "search", search);
		addParam(qparams, "searchOn", searchOn);
		addParam(qparams, "startsWith", startsWith);
		addParam(qparams, "endsWith", endsWith);
		addParam(qparams, "isRegex", isRegex);
		addParam(qparams, "sortOn", sortOn);
		addParam(qparams, "sortOrder", sortOrder);

		return qparams;
		
	}

}
